package com.example.test.helloworld2

import android.content.ComponentName
import android.content.Context
import android.content.Intent
import android.graphics.Bitmap
import android.media.MediaMetadata
import android.media.MediaMetadata.METADATA_KEY_ALBUM_ART
import android.media.session.MediaController
import android.media.session.MediaSessionManager
import android.media.session.PlaybackState.STATE_PLAYING
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.provider.MediaStore
import android.view.View

import android.util.Log

import android.widget.Button

import kotlinx.android.synthetic.main.activity_main.*


class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        button1.setOnClickListener(b1Click)
        button2.setOnClickListener(b2Click)

        val notify = NotificationListener()

        if(!notify.isEnabled(applicationContext)) {
            // 通知アクセス許可を得る
            startActivity(Intent("android.settings.ACTION_NOTIFICATION_LISTENER_SETTINGS"))
        }


    }

    var b1Click = object : View.OnClickListener {
        override fun onClick(p0: View?) {
            var ma = MediaAppHandler(p0?.context)
            var str = ma.getList()
            text1.text = str

            image1.setImageBitmap(ma.getActiveBitmap())

            text2.text = "Title: ${ma.getActiveTitle()}\nArtist: ${ma.getActiveArtist()}\nAlbum: ${ma.getActiveAlbum()}"




        }

    }

    var b2Click = object : View.OnClickListener {
        override fun onClick(p0: View?) {
            var ma=MediaAppHandler(p0?.context)

           text1.text = ma.getActiveKeyValueStr()



        }
    }


        inner class MediaAppHandler (context: Context?){
            val component = ComponentName(context, NotificationListener::class.java)
            val session = getSystemService(Context.MEDIA_SESSION_SERVICE) as MediaSessionManager
            var contList: List<MediaController> = session.getActiveSessions(component)


            fun getActiveKeyValueStr() : String {
                var cont = getActiveController()
                if(cont != null) return getKeyValueStr(cont)
                return "Empty"
            }


            fun getKeyValueStr(mediaController: MediaController) : String {
                var meta = mediaController.metadata
                var keys = meta.keySet()
                var str = StringBuilder()


                for (k in keys) {
                    str.append("$k = ${meta.getString(k)}\n")


                }
                return str.toString()


            }


            fun getActiveKeySet() : Set<String> {
                val cont = getActiveController()
                return cont?.metadata!!.keySet()
            }


            fun getActiveController() : MediaController? {
                for(cont in contList) {
                    var pbstate = cont.playbackState
                    if (pbstate == null) return null
                    if(pbstate.state == STATE_PLAYING) {
                        return cont
                    }

                }
                return null
            }

            fun getActiveTitle() : String{
                val cont=getActiveController()
                if(cont != null)  return cont.metadata!!.getString(MediaMetadata.METADATA_KEY_TITLE)
                return "Empty"

            }

            fun getActiveArtist() : String{
                val cont=getActiveController()
                if(cont != null)  return cont.metadata!!.getString(MediaMetadata.METADATA_KEY_ARTIST)
                return "Empty"

            }

            fun getActiveAlbum() : String{
                val cont=getActiveController()
                if(cont != null)  return cont.metadata!!.getString(MediaMetadata.METADATA_KEY_ALBUM)
                return "Empty"


            }

            fun getMetaStr(mediaController: MediaController?) : String {
                if(mediaController == null) return "Empty"

                var meta = mediaController.metadata
                var title = meta?.getString(MediaMetadata.METADATA_KEY_TITLE)
                var artist = meta?.getString(MediaMetadata.METADATA_KEY_ARTIST)
                var album = meta?.getString(MediaMetadata.METADATA_KEY_ALBUM)

                return "[$title][$artist][$album]"
            }



            fun getMetaBitmap(mediaController: MediaController?) : Bitmap? {
                if(mediaController == null) return null

                var meta = mediaController?.metadata
                return meta.getBitmap(METADATA_KEY_ALBUM_ART)
            }


            fun getActiveMetaStr() : String {
                return getMetaStr(getActiveController())
            }

            fun getActiveBitmap() : Bitmap? {
                return getMetaBitmap(getActiveController())
            }



            fun getList() : String {
                var str = StringBuilder()

                for (cont in contList) {
                            str.append("${cont.packageName} : ${getMetaStr(cont)}\n")
                }
                return str.toString()

            }
        }
    }






